## hipfft 6.4.3

=== CMakeLists.txt ===
# #############################################################################
# Copyright (C) 2020 - 2022 Advanced Micro Devices, Inc. All rights reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
# ############################################################################

# CMake version according to latest ROCm platform requirements
cmake_minimum_required( VERSION 3.17 )

# We use C++17 features, this will add compile option: -std=c++17
set( CMAKE_CXX_STANDARD 17 )
set(CMAKE_CXX_EXTENSIONS OFF)

# Consider removing this in the future
# This should appear before the project command, because it does not use FORCE
if( WIN32 )
  set( CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}/package" CACHE PATH
    "Install path prefix, prepended onto install directories" )
else()
  set( CMAKE_INSTALL_PREFIX "/opt/rocm" CACHE PATH
    "Install path prefix, prepended onto install directories" )
endif()


# Workarounds..
list( APPEND CMAKE_PREFIX_PATH /opt/rocm/llvm /opt/rocm )
list( APPEND CMAKE_MODULE_PATH ${ROCM_PATH}/lib/cmake/hip /opt/rocm/lib/cmake/hip /opt/rocm/hip/cmake )

# This has to be initialized before the project() command appears
# Set the default of CMAKE_BUILD_TYPE to be release, unless user specifies with -D.
# MSVC_IDE does not use CMAKE_BUILD_TYPE
if( NOT DEFINED CMAKE_CONFIGURATION_TYPES AND NOT DEFINED CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." )
endif()

set( HIPFFT_BUILD_SCOPE ON )

project( hipfft LANGUAGES CXX )

# Build options
option( BUILD_SHARED_LIBS "Build ${PROJECT_NAME} as a shared library" ON )
option( BUILD_VERBOSE "Output additional build information" OFF )
option( HIPFFT_MPI_ENABLE "Build with MPI support for distributed transforms" OFF )

set( BUILD_WITH_COMPILER "HOST-default" CACHE INTERNAL
     "Build ${PROJECT_NAME} with compiler HIP-clang, HIP-nvcc, or just the host default compiler, eg g++")
set( BUILD_WITH_LIB "ROCM" CACHE STRING "Build ${PROJECT_NAME} with ROCM or CUDA libraries" )

option( BUILD_CLIENTS "Build all clients" OFF)
option( BUILD_CLIENTS_BENCH "Build benchmark client" OFF )
option( BUILD_CLIENTS_TESTS "Build ${PROJECT_NAME} tests (requires 3rd dependencies)" OFF )
option( BUILD_CLIENTS_SAMPLES "Build examples" OFF )
option(BUILD_ADDRESS_SANITIZER "Build with address sanitizer enabled" OFF)

# Provide ability to disable hipRAND dependency
option(USE_HIPRAND "Build using hipRAND for test input generation instead of host-side generation" ON)

if( USE_HIPRAND )
  add_compile_definitions(USE_HIPRAND)
endif( )

option( WERROR "Treat warnings as errors" OFF )

set(DEFAULT_GPUS
  gfx803
  gfx900
  gfx906
  gfx908
  gfx90a
  gfx940
  gfx941
  gfx942
  gfx1030
  gfx1100
  gfx1101
  gfx1102
  gfx1151
  gfx1200
  gfx1201)

if(BUILD_ADDRESS_SANITIZER)
  add_compile_options(-fsanitize=address)
  add_link_options(-fsanitize=address)
  add_link_options(-shared-libasan)
  SET(DEFAULT_GPUS
    gfx908:xnack+
    gfx90a:xnack+
    gfx940:xnack+
    gfx941:xnack+
    gfx942:xnack+)
  add_link_options(-fuse-ld=lld)
  add_compile_definitions(ADDRESS_SANITIZER)
endif()

# Set internal BUILD_WITH_COMPILER.
if(NOT (CMAKE_CXX_COMPILER MATCHES ".*hipcc$" OR CMAKE_CXX_COMPILER MATCHES ".*clang\\+\\+"))
  set( BUILD_WITH_COMPILER "HOST-default" )
else()
  if( $ENV{HIP_PLATFORM} MATCHES "nvidia" )
    set( BUILD_WITH_COMPILER "HIP-nvcc" )
  else()
    set( BUILD_WITH_COMPILER "HIP-clang" )
    if( NOT BUILD_WITH_LIB STREQUAL "ROCM" )
      message( FATAL_ERROR "Detected HIP_COMPILER=clang, but BUILD_WITH_LIB is not ROCM!" )
    endif()
  endif()
endif()

string( TOUPPER "${BUILD_WITH_COMPILER}" BUILD_WITH_COMPILER )
string( TOUPPER "${BUILD_WITH_LIB}" BUILD_WITH_LIB )

# nvc++ doesn't understand warning flags
if( NOT CMAKE_CXX_COMPILER MATCHES ".*nvc\\+\\+" )
  set( WARNING_FLAGS -Wall -Wno-unused-function -Wimplicit-fallthrough -Wunreachable-code -Wno-unknown-pragmas)
  if( WERROR )
    set( WARNING_FLAGS ${WARNING_FLAGS} -Werror )
  endif()
endif()

# Dependencies
include(cmake/dependencies.cmake)

if (BUILD_WITH_COMPILER STREQUAL "HIP-NVCC" )
  set (BUILD_WITH_LIB "CUDA")
  set( HIP_PLATFORM "nvidia" )

  set( CMAKE_CXX_EXTENSIONS OFF )

  set( CMAKE_CXX_COMPILE_OPTIONS_PIC "-Xcompiler=${CMAKE_CXX_COMPILE_OPTIONS_PIC}" )

  set( CMAKE_SHARED_LIBRARY_C_FLAGS "-Xlinker=${CMAKE_SHARED_LIBRARY_C_FLAGS}" )
  set( CMAKE_SHARED_LIBRARY_CXX_FLAGS "-Xlinker=${CMAKE_SHARED_LIBRARY_CXX_FLAGS}" )
  set( CMAKE_SHARED_LIBRARY_SONAME_C_FLAG "-Xlinker=-soname," )
  set( CMAKE_SHARED_LIBRARY_SONAME_CXX_FLAG "-Xlinker=-soname," )

  set( CMAKE_SHARED_LIBRARY_RUNTIME_C_FLAG "-Xlinker=-rpath," )
  set( CMAKE_SHARED_LIBRARY_RUNTIME_CXX_FLAG "-Xlinker=-rpath," )
  set( CMAKE_EXECUTABLE_RUNTIME_C_FLAG "-Xlinker=-rpath," )
  set( CMAKE_EXECUTABLE_RUNTIME_CXX_FLAG "-Xlinker=-rpath," )

  set( CMAKE_C_COMPILE_OPTIONS_VISIBILITY "-Xcompiler='${CMAKE_C_COMPILE_OPTIONS_VISIBILITY}'" )
  set( CMAKE_CXX_COMPILE_OPTIONS_VISIBILITY "-Xcompiler='${CMAKE_CXX_COMPILE_OPTIONS_VISIBILITY}'" )
  set( CMAKE_C_COMPILE_OPTIONS_VISIBILITY_INLINES_HIDDEN
    "-Xcompiler='${CMAKE_C_COMPILE_OPTIONS_VISIBILITY_INLINES_HIDDEN}'" )
  set( CMAKE_CXX_COMPILE_OPTIONS_VISIBILITY_INLINES_HIDDEN
    "-Xcompiler='${CMAKE_CXX_COMPILE_OPTIONS_VISIBILITY_INLINES_HIDDEN}'" )

  foreach( FLAG IN ITEMS ${WARNING_FLAGS} )
    set( NVCC_WARNING_FLAGS ${NVCC_WARNING_FLAGS} "-Xcompiler=${FLAG}" )
  endforeach()
  set( WARNING_FLAGS ${NVCC_WARNING_FLAGS} )

else()
  # Define GPU targets
  if(AMDGPU_TARGETS AND NOT GPU_TARGETS)
    message( DEPRECATION "AMDGPU_TARGETS use is deprecated. Use GPU_TARGETS." )
  endif()
  set(AMDGPU_TARGETS "${DEFAULT_GPUS}" CACHE STRING "Target default GPUs if AMDGPU_TARGETS is not defined. (Deprecated, prefer GPU_TARGETS)")
  rocm_check_target_ids(AMDGPU_TARGETS TARGETS "${AMDGPU_TARGETS}")
  # Don't force, users should be able to override GPU_TARGETS at the command line if desired
  set(GPU_TARGETS "${AMDGPU_TARGETS}" CACHE STRING "GPU architectures to build for")
  if( BUILD_WITH_COMPILER STREQUAL "HIP-CLANG" )
    set( HIP_PLATFORM "amd" )
    set( HIP_COMPILER "clang" )
  endif()
endif()

# Show the actual compiler(internal option)
message(STATUS "BUILD_WITH_COMPILER = " ${BUILD_WITH_COMPILER})

# FOR HANDLING ENABLE/DISABLE OPTIONAL BACKWARD COMPATIBILITY for FILE/FOLDER REORG
option(BUILD_FILE_REORG_BACKWARD_COMPATIBILITY "Build with file/folder reorg with backward compatibility enabled" OFF)
if(BUILD_FILE_REORG_BACKWARD_COMPATIBILITY AND NOT WIN32)
  rocm_wrap_header_dir(
    ${CMAKE_SOURCE_DIR}/library/include
    PATTERNS "*.h"
    GUARDS SYMLINK WRAPPER
    WRAPPER_LOCATIONS ${CMAKE_INSTALL_INCLUDEDIR}
  )
endif()

# Version
set( VERSION_STRING "1.0.18" )
set( hipfft_SOVERSION 0.1 )

if( ROCM_FOUND )
  rocm_setup_version( VERSION ${VERSION_STRING} )
endif()

add_subdirectory( library )

# Build clients of the library
if( BUILD_CLIENTS )
  set( BUILD_CLIENTS_BENCH ON )
  set( BUILD_CLIENTS_SAMPLES ON )
  set( BUILD_CLIENTS_TESTS ON )
endif()

# old name for BUILD_CLIENTS_BENCH
if( BUILD_CLIENTS_RIDER )
  set( BUILD_CLIENTS_BENCH ${BUILD_CLIENTS_RIDER} )
endif()

# Build clients of the library
if( BUILD_CLIENTS_BENCH OR BUILD_CLIENTS_SAMPLES OR BUILD_CLIENTS_TESTS )
  include( clients/cmake/build-options.cmake )
  rocm_package_setup_component(clients)
  if(NOT CLIENTS_OS)
    rocm_set_os_id(CLIENTS_OS)
    string(TOLOWER "${CLIENTS_OS}" CLIENTS_OS)
    rocm_read_os_release(CLIENTS_OS_VERSION VERSION_ID)
  endif()
  message(STATUS "OS: ${CLIENTS_OS} ${CLIENTS_OS_VERSION}")
  set(FFTW_DEB "libfftw3-bin")
  if(CLIENTS_OS STREQUAL "sles")
    set(FFTW_RPM "libfftw3-3")
  elseif(CLIENTS_OS STREQUAL "mariner")
    set(BOOST_RPM RPM "boost = ${Boost_VERSION_MAJOR}_${Boost_VERSION_MINOR}_${Boost_VERSION_PATCH}")
    set(FFTW_RPM "fftw-libs")
  else()
    set(FFTW_RPM "fftw-libs")
  endif()
  if( USE_HIPRAND )
    set( HIPRAND_DEP hiprand )
  endif()
  if(BUILD_CLIENTS_TESTS)
    rocm_package_setup_client_component(
      tests
      DEPENDS
        DEB ${FFTW_DEB} ${HIPRAND_DEP}
        RPM ${FFTW_RPM} ${HIPRAND_DEP}
      )
  endif()
  if(BUILD_CLIENTS_BENCH)
    rocm_package_setup_client_component(
      benchmarks
      DEPENDS
        DEB ${HIPRAND_DEP}
        RPM ${HIPRAND_DEP}
      )
  endif()
  add_subdirectory( clients )
endif()

# Packaging...
if(WIN32)
  set(CPACK_SOURCE_GENERATOR "ZIP")
  set(CPACK_GENERATOR "ZIP")
  set(CMAKE_INSTALL_PREFIX "C:/hipSDK" CACHE PATH "Install path" FORCE)
  set(INSTALL_PREFIX "C:/hipSDK")
  set(CPACK_SET_DESTDIR OFF)
  set(CPACK_PACKAGE_INSTALL_DIRECTORY "C:/hipSDK")
  set(CPACK_PACKAGING_INSTALL_PREFIX "")
  set(CPACK_INCLUDE_TOPLEVEL_DIRECTORY OFF)
endif()

if( ROCM_FOUND )
  # Package specific CPACK vars
  if( NOT BUILD_WITH_LIB STREQUAL "CUDA" )
    rocm_package_add_dependencies(DEPENDS "rocfft >= 1.0.21")
  else()
    if( NVHPC_FOUND )
      string( REPLACE "." "-" NVHPC_PKG_VERSION ${NVHPC_VERSION} )
      rocm_package_add_dependencies(DEPENDS "nvhpc-${NVHPC_PKG_VERSION}")
    else()
      rocm_package_add_dependencies(DEPENDS "cufft >= 10.0.0")
    endif()
  endif()

  set( CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.md" )

  set( CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION "\${CPACK_PACKAGING_INSTALL_PREFIX}" )

  # Give hipfft compiled for CUDA backend a different name
  if( BUILD_WITH_LIB STREQUAL "ROCM" )
    set( package_name hipfft )
  else()
    set( package_name hipfft-alt )
  endif()

  set( HIPFFT_CONFIG_DIR "\${CPACK_PACKAGING_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}" CACHE PATH "Path placed into ldconfig file" )

  rocm_create_package(
    NAME ${package_name}
    DESCRIPTION "ROCm FFT marshalling library"
    MAINTAINER "hipfft-maintainer@amd.com"
    LDCONFIG
    LDCONFIG_DIR ${HIPFFT_CONFIG_DIR}
    )
endif()

=== clients/CMakeLists.txt ===
# #############################################################################
# Copyright (C) 2020 - 2023 Advanced Micro Devices, Inc. All rights reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
# #############################################################################

# CMake version according to latest ROCm platform requirements
cmake_minimum_required( VERSION 3.16 )

# We use C++17 features, this will add compile option: -std=c++17
set( CMAKE_CXX_STANDARD 17 )
set(CMAKE_CXX_EXTENSIONS OFF)

# Consider removing this in the future
# This should appear before the project command, because it does not use FORCE
if( WIN32 )
  set( CMAKE_INSTALL_PREFIX
    "${PROJECT_BINARY_DIR}/package"
    CACHE
    PATH
    "Install path prefix, prepended onto install directories" )
else( )
  set( CMAKE_INSTALL_PREFIX
    "/opt/rocm"
    CACHE
    PATH
    "Install path prefix, prepended onto install directories" )
endif( )

# This has to be initialized before the project() command appears
# Set the default of CMAKE_BUILD_TYPE to be release, unless user specifies with -D.  MSVC_IDE does
# not use CMAKE_BUILD_TYPE
if( NOT DEFINED CMAKE_CONFIGURATION_TYPES AND NOT DEFINED CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." )
endif()

set( HIPFFT_CLIENTS_BUILD_SCOPE ON )

# This project may compile dependencies for clients
project( hipfft-clients LANGUAGES CXX )

list( APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake )

include( build-options )

if(NOT (CMAKE_CXX_COMPILER MATCHES ".*hipcc$" OR
        CMAKE_CXX_COMPILER MATCHES ".*clang\\+\\+" OR
	CMAKE_CXX_COMPILER MATCHES ".*nvcc" OR
	CMAKE_CXX_COMPILER MATCHES ".*nvc\\+\\+"
  	)
  )
  if(BUILD_CLIENTS)
    message( FATAL_ERROR "Using BUILD_CLIENTS=ON requires a compiler capable of building device code (hipcc, clang, nvcc, nvc++)." )
  endif()
endif()


# This option only works for make/nmake and the ninja generators, but no reason it shouldn't be on
# all the time
# This tells cmake to create a compile_commands.json file that can be used with clang tooling or vim
set( CMAKE_EXPORT_COMPILE_COMMANDS ON )

# if hipfft is not a target, then we know clients are built separately from the library and we must
# search for the hipfft package
if( NOT TARGET hipfft )
  find_package( hipfft REQUIRED CONFIG PATHS )
endif( )

if( BUILD_CLIENTS_SAMPLES )
  add_subdirectory( samples )
endif( )

if( BUILD_CLIENTS_TESTS )
  find_package( GTest 1.11.0 )
  include( ExternalProject )
  if( NOT GTEST_FOUND )
    set( GTEST_INCLUDE_DIRS
      ${CMAKE_CURRENT_BINARY_DIR}/src/gtest/googletest/include
      )
    set( GTEST_LIBRARIES
      ${CMAKE_CURRENT_BINARY_DIR}/src/gtest-build/lib/${CMAKE_STATIC_LIBRARY_PREFIX}gtest${CMAKE_STATIC_LIBRARY_SUFFIX}
      ${CMAKE_CURRENT_BINARY_DIR}/src/gtest-build/lib/${CMAKE_STATIC_LIBRARY_PREFIX}gtest_main${CMAKE_STATIC_LIBRARY_SUFFIX}
      )

    ExternalProject_Add( gtest
      URL https://github.com/google/googletest/archive/release-1.11.0.tar.gz
      URL_HASH SHA256=b4870bf121ff7795ba20d20bcdd8627b8e088f2d1dab299a031c1034eddc93d5
      PREFIX ${CMAKE_CURRENT_BINARY_DIR}
      CMAKE_ARGS -DCMAKE_CXX_COMPILER_LAUNCHER=${CMAKE_CXX_COMPILER_LAUNCHER} -DBUILD_SHARED_LIBS=OFF
        -DCMAKE_POSITION_INDEPENDENT_CODE=ON
      INSTALL_COMMAND ""
      BUILD_BYPRODUCTS ${GTEST_LIBRARIES}
      )
    ExternalProject_Get_Property( gtest source_dir binary_dir )
  endif()
  add_subdirectory( tests )
endif( )

if( BUILD_CLIENTS_BENCH )
  add_subdirectory( bench )
endif( )

=== library/CMakeLists.txt ===
# #############################################################################
# Copyright (C) 2020 - 2022 Advanced Micro Devices, Inc. All rights reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
# ############################################################################


# This option only works for make/nmake and the ninja generators, but no reason it shouldn't be on
# all the time.
# This tells cmake to create a compile_commands.json file that can be used with clang tooling or vim
set( CMAKE_EXPORT_COMPILE_COMMANDS ON )

# Print verbose compiler flags
if( BUILD_VERBOSE )
  include( ../cmake/verbose.cmake )
endif()

find_package(HIP REQUIRED)
set(HIP_INCLUDE_DIRS "${HIP_ROOT_DIR}/include")

# Configure a header file to pass the hipFFT version
configure_file( "${CMAKE_CURRENT_SOURCE_DIR}/include/hipfft/hipfft-version.h.in"
  "${PROJECT_BINARY_DIR}/include/hipfft/hipfft-version.h"
  )

# Public hipFFT headers
set( hipfft_headers_public
  include/hipfft/hipfft.h
  include/hipfft/hipfftXt.h
  include/hipfft/hipfftMp.h
  ${PROJECT_BINARY_DIR}/include/hipfft/hipfft-version.h
  )

source_group( "Header Files\\Public" FILES ${hipfft_headers_public} )

# Include sources
include( src/CMakeLists.txt )

# Create hipFFT library
add_library( hipfft ${hipfft_source} ${hipfft_headers_public} )
add_library( hip::hipfft ALIAS hipfft )
if( BUILD_WITH_LIB STREQUAL "CUDA" )
  # static hipfft build should link against static cufft
  if( BUILD_SHARED_LIBS )
    if( NVHPC_FOUND )
      if( HIPFFT_MPI_ENABLE )
        target_link_libraries( hipfft PRIVATE NVHPC::CUFFTMP )
      else()
        target_link_libraries( hipfft PRIVATE NVHPC::CUFFT )
      endif()
    else()
      target_link_libraries( hipfft PRIVATE CUDA::cufft )
    endif()
  else()
    if( NVHPC_FOUND )
      target_link_libraries( hipfft PRIVATE NVHPC::CUFFT_static )
    else()
      target_link_libraries( hipfft PRIVATE CUDA::cufft_static )
    endif()
  endif()
endif()

set(static_depends)

# Target compile definitions
if( BUILD_WITH_COMPILER STREQUAL "HOST-DEFAULT" )
  if( BUILD_WITH_LIB STREQUAL "ROCM" )
    target_compile_definitions( hipfft PRIVATE __HIP_PLATFORM_AMD__ )
  else()
    target_compile_definitions( hipfft PRIVATE __HIP_PLATFORM_NVIDIA__ )
  endif()
endif()

if( HIPFFT_MPI_ENABLE )
  target_compile_definitions( hipfft PRIVATE HIPFFT_MPI_ENABLE )
endif()

# Target include directories
# Hip header files installed in cmake install includedir
# HIP_INCLUDE_DIRS is not required
target_include_directories( hipfft
  PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/include>
  PUBLIC  $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/library/include>
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include/hipfft>
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
  $<BUILD_INTERFACE:${HIP_INCLUDE_DIRS}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  )

if( BUILD_WITH_LIB STREQUAL "CUDA" )
  target_include_directories( hipfft PUBLIC $<BUILD_INTERFACE:${CUDAToolkit_INCLUDE_DIRS}> )
endif()

# Target link libraries - on ROCm we just use rocFFT for
# everything.  CUDA has to be handled separately for normal and
# "Mp" libs
if( BUILD_WITH_LIB STREQUAL "ROCM" )
  list(APPEND static_depends PACKAGE rocfft)
  target_link_libraries( hipfft PRIVATE roc::rocfft )
  if( WIN32 )
    target_link_libraries( hipfft PRIVATE hip::device )
  endif()
  target_link_libraries( hipfft PUBLIC hip::host )
endif()

target_compile_options( hipfft PRIVATE ${WARNING_FLAGS} )

# Target properties
set_target_properties( hipfft PROPERTIES CXX_EXTENSIONS NO )
set_target_properties( hipfft PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )

if (BUILD_WITH_COMPILER STREQUAL "HIP-NVCC" )
  set_property(TARGET hipfft PROPERTY POSITION_INDEPENDENT_CODE ON)
  set ( CXX_FLAGS "${CXX_FLAGS} -Xcompiler=-fPIC" )
endif()

#TODO:
# hipcc(with nvcc backend) build has problem for share library visibility,
# need to figure out the reason and enable visibility "hidden" for nvcc eventually.
if( NOT BUILD_WITH_COMPILER STREQUAL "HIP-NVCC" )
  set_target_properties( hipfft
    PROPERTIES CXX_VISIBILITY_PRESET "hidden" VISIBILITY_INLINES_HIDDEN ON )
endif()

# nvcc can not recognize shared library file name with suffix other than *.so when linking.
if (NOT BUILD_WITH_COMPILER STREQUAL "HIP-NVCC")
  rocm_set_soversion(hipfft ${hipfft_SOVERSION})
endif()

# Generate export header
include( GenerateExportHeader )
generate_export_header( hipfft EXPORT_FILE_NAME ${PROJECT_BINARY_DIR}/include/hipfft/hipfft-export.h )

execute_process(COMMAND ${CMAKE_COMMAND} -E copy_directory ${PROJECT_SOURCE_DIR}/library/include ${PROJECT_BINARY_DIR}/include)
if (BUILD_FILE_REORG_BACKWARD_COMPATIBILITY AND NOT WIN32)
  rocm_wrap_header_file(
    hipfft-version.h hipfft-export.h
    GUARDS SYMLINK WRAPPER
    WRAPPER_LOCATIONS ${CMAKE_INSTALL_INCLUDEDIR} hipfft/${CMAKE_INSTALL_INCLUDEDIR}
    ORIGINAL_FILES ${PROJECT_BINARY_DIR}/include/hipfft/hipfft-version.h
  )
endif( )

if( ROCM_FOUND )

  rocm_install_targets( TARGETS hipfft
    INCLUDE
    ${CMAKE_BINARY_DIR}/include
  )

  if(BUILD_FILE_REORG_BACKWARD_COMPATIBILITY AND NOT WIN32)
    rocm_install(
    DIRECTORY
       "${PROJECT_BINARY_DIR}/hipfft"
        DESTINATION "." )
    message( STATUS "Backward Compatible Sym Link Created for include directories" )
  endif()


  rocm_export_targets( TARGETS hip::hipfft
    DEPENDS PACKAGE hip
    STATIC_DEPENDS
      ${static_depends}
    NAMESPACE hip:: )
endif()

=== clients/bench/CMakeLists.txt ===
# #############################################################################
# Copyright (C) 2020 - 2023 Advanced Micro Devices, Inc. All rights reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
# #############################################################################

CMAKE_MINIMUM_REQUIRED(VERSION 3.16)

project( hipfft-clients-bench LANGUAGES CXX )

set( hipfft_bench_source bench.cpp ../../shared/array_validator.cpp )
set( hipfft_bench_includes bench.h ../../shared/array_validator.h )

add_executable( hipfft-bench ${hipfft_bench_source} ${hipfft_bench_includes} )

target_compile_options( hipfft-bench PRIVATE ${WARNING_FLAGS} )

set_target_properties( hipfft-bench PROPERTIES CXX_STANDARD 17 CXX_STANDARD_REQUIRED ON )

target_include_directories( hipfft-bench
  PRIVATE
  $<BUILD_INTERFACE:${hip_INCLUDE_DIRS}>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../../library/include>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../rocFFT/library/include>
  )
  
if((NOT CMAKE_CXX_COMPILER MATCHES ".*/hipcc$") OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  if( NOT BUILD_WITH_LIB STREQUAL "CUDA" )
    if( WIN32 )
      find_package( HIP CONFIG REQUIRED )
    else()
      find_package( HIP MODULE REQUIRED )
    endif()

    target_link_libraries( hipfft-bench PRIVATE hip::host hip::device )
  else()
    target_compile_definitions( hipfft-bench PRIVATE __HIP_PLATFORM_NVIDIA__)
    target_include_directories( hipfft-bench PRIVATE ${HIP_INCLUDE_DIRS})
  endif()
endif()

if ( BUILD_WITH_LIB STREQUAL "CUDA" )
  if( CMAKE_CXX_COMPILER MATCHES ".*nvc\\+\\+$" )
    target_compile_options( hipfft-bench PRIVATE -cuda -Xptxas=-w)
    target_link_options( hipfft-bench PRIVATE -cuda)
  else()
    target_compile_options( hipfft-bench PRIVATE -arch sm_53 -gencode=arch=compute_53,code=sm_53 -Xptxas=-w)
  endif()
  target_link_libraries( hipfft-bench PRIVATE ${CUDA_LIBRARIES} )
else()
  if( USE_HIPRAND AND NOT hiprand_FOUND )
    find_package( hiprand REQUIRED )
  endif()
  if( USE_HIPRAND )
    target_link_libraries( hipfft-bench PRIVATE hip::hiprand )
  endif()
endif()

target_link_libraries( hipfft-bench PRIVATE hip::hipfft )

set_target_properties( hipfft-bench PROPERTIES CXX_EXTENSIONS NO )
set_target_properties( hipfft-bench PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )

if( HIPFFT_BUILD_SCOPE )
  set( BENCH_OUT_DIR "/../staging" )
elseif( HIPFFT_CLIENTS_BUILD_SCOPE )
  set( BENCH_OUT_DIR "/../bin" )
else()
  set( BENCH_OUT_DIR "/bin")
endif()
string( CONCAT BENCH_OUT_DIR "${PROJECT_BINARY_DIR}" ${BENCH_OUT_DIR} )

set_target_properties( hipfft-bench
  PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY
  ${BENCH_OUT_DIR} )

rocm_install(TARGETS hipfft-bench COMPONENT benchmarks)

# install compatibility for old name of bench program - symlink on
# unix, hardlink on windows (since privilege is required to create
# symlinks there)
if( WIN32 )
  set( BENCH_LINK_COMMAND create_hardlink )
  set( BENCH_NEW_NAME ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/hipfft-bench${CMAKE_EXECUTABLE_SUFFIX} )
  set( BENCH_OLD_NAME ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/hipfft-rider${CMAKE_EXECUTABLE_SUFFIX} )
else()
  set( BENCH_LINK_COMMAND create_symlink )
  set( BENCH_NEW_NAME hipfft-bench )
  set( BENCH_OLD_NAME ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/hipfft-rider )
endif()
install(
  CODE "execute_process( COMMAND \"${CMAKE_COMMAND}\" -E ${BENCH_LINK_COMMAND} \"${BENCH_NEW_NAME}\" \"${BENCH_OLD_NAME}\" )"
)

=== clients/samples/CMakeLists.txt ===
# #############################################################################
# Copyright (C) 2016 - 2023 Advanced Micro Devices, Inc. All rights reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
# #############################################################################

CMAKE_MINIMUM_REQUIRED( VERSION 3.16 )

project( hipfft-clients-samples-rocfft LANGUAGES CXX )

# We use C++17 features, this will add compile option: -std=c++17
set( CMAKE_CXX_STANDARD 17 )

if( NOT TARGET hipfft )
  find_package( hipfft REQUIRED CONFIG PATHS )
endif( )

set( sample_list
  hipfft_1d_z2z
  hipfft_1d_d2z
  hipfft_2d_z2z
  hipfft_2d_d2z
  hipfft_3d_z2z
  hipfft_3d_d2z
  hipfft_planmany_2d_z2z
  hipfft_planmany_2d_r2c
  hipfft_multigpu_2d_z2z
  hipfft_setworkarea
  )

# callback sample has its own HIP code, so it needs to be built with hipcc or clang++
if( CMAKE_CXX_COMPILER MATCHES ".*/hipcc$" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang" )
  # on cuFFT backend, use of callbacks requires linking against the
  # static cuFFT library
  if( NOT (BUILD_WITH_LIB STREQUAL "CUDA") OR NOT BUILD_SHARED_LIBS )
    list( APPEND sample_list hipfft_callback )
  else()
    message( STATUS "hipfft_callback sample disabled on non-static CUDA build" )
  endif()
else()
  message( STATUS "hipfft_callback sample disabled, requires hipcc or Clang++ build" )
endif()

foreach( sample ${sample_list} )

  add_executable( ${sample} ${sample}.cpp )

  set_target_properties( ${sample} PROPERTIES CXX_STANDARD 17 CXX_STANDARD_REQUIRED ON )

  target_link_libraries( ${sample} PRIVATE hip::hipfft )

  target_compile_options( ${sample} PRIVATE ${WARNING_FLAGS} )
  
  if( NOT CMAKE_CXX_COMPILER MATCHES ".*/hipcc$" )
    if( WIN32 )
      find_package( HIP CONFIG REQUIRED )
    else()
      find_package( HIP MODULE REQUIRED )
    endif()
    if( NOT BUILD_WITH_LIB STREQUAL "CUDA" )
      target_link_libraries( ${sample} PRIVATE hip::host hip::device )
    else()
      target_compile_definitions( ${sample} PRIVATE __HIP_PLATFORM_NVIDIA__)
      target_include_directories( ${sample} PRIVATE ${HIP_INCLUDE_DIRS})
    endif()
  endif()

  if ( BUILD_WITH_LIB STREQUAL "CUDA" )
    if( CMAKE_CXX_COMPILER MATCHES ".*nvc\\+\\+$" )
      target_compile_options( ${sample} PRIVATE -cuda -Xptxas=-w)
      target_link_options( ${sample} PRIVATE -cuda)
    else()
      target_compile_options( ${sample} PRIVATE -arch sm_53 -gencode=arch=compute_53,code=sm_53 -Xptxas=-w)
    endif()
    target_link_libraries( ${sample} PRIVATE ${CUDA_LIBRARIES} )
  else()
    if( USE_HIPRAND AND NOT hiprand_FOUND )
      find_package( hiprand REQUIRED )
    endif()
    if ( USE_HIPRAND )
      target_link_libraries( ${sample} PRIVATE hip::hiprand )
    endif()
  endif()

  target_include_directories( ${sample}
    PRIVATE
    $<BUILD_INTERFACE:${hip_INCLUDE_DIRS}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../../library/include>
    ${HIP_ROOT_DIR}
    )
  
  set_target_properties( ${sample} PROPERTIES CXX_EXTENSIONS NO )
  
  if( HIPFFT_BUILD_SCOPE )
    set( SAMPLES_OUT_DIR "/../staging" )
  elseif( HIPFFT_CLIENTS_BUILD_SCOPE )
    set( SAMPLES_OUT_DIR "/../bin" )
  else()
    set( SAMPLES_OUT_DIR "/bin" )
  endif()
  string( CONCAT SAMPLES_OUT_DIR "${PROJECT_BINARY_DIR}" ${SAMPLES_OUT_DIR} )

  set_target_properties( ${sample}
                         PROPERTIES 
                         RUNTIME_OUTPUT_DIRECTORY 
                         ${SAMPLES_OUT_DIR} )
  
endforeach()

# cuFFT callback code must be compiled with -dc to enable relocatable
# device code
if( BUILD_WITH_LIB STREQUAL "CUDA" AND hipfft_callback IN_LIST sample_list )
  target_compile_options( hipfft_callback PRIVATE -dc )
endif()

=== debian/changelog ===
hipfft (6.4.3-2) unstable; urgency=medium

  * Re-upload to unstable with orginal tarball

 -- Cordell Bloor <cgmb@debian.org>  Mon, 10 Nov 2025 08:34:10 -0700

hipfft (6.4.3-1) unstable; urgency=medium

  [ Cordell Bloor ]
  * Upload to unstable
  * Remove Maxime Chambonnet from uploaders
  * Update my email address and copyright information
  * Add d/p/fix-optional-hiprand.patch and build with USE_HIPRAND=OFF
    to remove use of hiprand from the hipfft tests
  * Enable CMAKE_SKIP_INSTALL_RPATH to use rpath for build-time tests
  * Use GPU_TARGETS rather than deprecated AMDGPU_TARGETS
  * Add prompt for rocminfo output to library and test bug reports

  [ Kentaro Hayashi ]
  * Use d/watch 5

 -- Cordell Bloor <cgmb@debian.org>  Sat, 08 Nov 2025 14:12:11 -0700

hipfft (6.4.3-1~exp1) experimental; urgency=medium

  * New upstream version 6.4.3
  * Update for new rocm-target-arch

 -- Christian Kastner <ckk@debian.org>  Sat, 09 Aug 2025 09:46:47 +0200

hipfft (6.4.1-1~exp2) experimental; urgency=medium

  * Improve the run-tests runner
  * Use rocm-target-arch to select and document GPU arch
  * d/rules: Fix typo in DEB_BUILD_PROFILES envvar name
  * Update repo layout to DEP-14

 -- Christian Kastner <ckk@debian.org>  Fri, 11 Jul 2025 16:44:21 +0200

=== debian/control ===
Source: hipfft
Section: devel
Homepage: https://github.com/ROCm/hipfft
Priority: optional
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/rocm-team/hipfft.git
Vcs-Browser: https://salsa.debian.org/rocm-team/hipfft
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Cordell Bloor <cgmb@debian.org>,
           Christian Kastner <ckk@debian.org>,
           Kari Pahula <kaol@debian.org>,
Build-Depends: debhelper-compat (= 13),
               hipcc (>= 5.6.1~),
               cmake,
               rocm-cmake,
               librocfft-dev (>= 6.4.1~),
               libboost-program-options-dev <!nocheck>,
               libfftw3-dev <!nocheck>,
               libgtest-dev <!nocheck>,
               pkg-rocm-tools (>= 0.9.0~exp3),
Build-Depends-Indep: dh-sequence-sphinxdoc <!nodoc>,
               python3-doxysphinx <!nodoc>,
               python3-rocm-docs (>= 1.20.0-1~) <!nodoc>,
               python3-sphinx-external-toc <!nodoc>,
               libjs-jquery <!nodoc>,
               libjs-mathjax <!nodoc>,
               libjs-sphinxdoc <!nodoc>,
               libjs-underscore <!nodoc>
Rules-Requires-Root: no

Package: libhipfft0
Section: libs
Architecture: amd64 arm64 ppc64el
XB-X-ROCm-GPU-Architecture: ${rocm:GPU-Architecture}
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: portable interface for Fast Fourier Transforms on the GPU - library
 hipFFT is a wrapper library that provides a common interface to rocFFT and
 cuFFT. The hipFFT library is designed to help applications using cuFFT to port
 their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipFFT library.

Package: libhipfft-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: libhipfft0 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
         libamdhip64-dev,
Suggests: libhipfft-doc
Description: portable interface for Fast Fourier Transforms on the GPU - headers
 hipFFT is a wrapper library that provides a common interface to rocFFT and
 cuFFT. The hipFFT library is designed to help applications using cuFFT to port
 their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipFFT development headers.

Package: libhipfft0-tests
Section: libdevel
Architecture: amd64 arm64 ppc64el
Build-Profiles: <!nocheck>
Depends: libhipfft0 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
Description: portable interface for Fast Fourier Transforms on the GPU - tests
 hipFFT is a wrapper library that provides a common interface to rocFFT and
 cuFFT. The hipFFT library is designed to help applications using cuFFT to port
 their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipFFT test binaries. These binaries are
 only used to check whether hipFFT works correctly on a given GPU, so
 generally speaking, users probably don't need this package.

Package: libhipfft-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-mathjax,
Breaks: libhipfft-dev (<< 5.7.1-1~)
Replaces: libhipfft-dev (<< 5.7.1-1~)
Description: portable interface for Fast Fourier Transforms on the GPU - documentation
 hipFFT is a wrapper library that provides a common interface to rocFFT and
 cuFFT. The hipFFT library is designed to help applications using cuFFT to port
 their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipFFT documentation.

=== debian/rules ===
#!/usr/bin/make -f
export CXX=hipcc
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
export DEB_CXXFLAGS_MAINT_PREPEND = -gz
export VERBOSE=1

# filter incompatible options from affecting device code
CXXFLAGS := $(subst -fstack-protector-strong,-Xarch_host -fstack-protector-strong,$(CXXFLAGS))
CXXFLAGS := $(subst -fcf-protection,-Xarch_host -fcf-protection,$(CXXFLAGS))

CMAKE_FLAGS = \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_SKIP_INSTALL_RPATH=ON \
	-DROCM_SYMLINK_LIBS=OFF \
	-DGPU_TARGETS="$(shell rocm-target-arch --sep ';')" \
	-DBUILD_CLIENTS_TESTS_OPENMP=OFF

# The hipfft test client requires the rocfft sources to build.
ifeq (,$(filter nocheck,$(DEB_BUILD_PROFILES)))
CMAKE_FLAGS += -DBUILD_CLIENTS_TESTS=ON \
	-DUSE_HIPRAND=OFF
endif

%:
	dh $@

override_dh_auto_configure-arch:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	set -e \
	; if [ -r /dev/kfd ] \
	; then obj-$(DEB_HOST_GNU_TYPE)/clients/staging/hipfft-test \
	; else echo "W: /dev/kfd unreadable: no available AMD GPU." \
	;      echo "W: tests skipped." \
	; fi
endif

override_dh_auto_configure-indep:
	:

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	http_proxy='127.0.0.1:9' \
	https_proxy='127.0.0.1:9' \
	ROCM_DOCS_REMOTE_DETAILS=http://localhost,local \
	latest_version= \
	release_candidate= \
	sphinx-build -b html docs html
endif

override_dh_auto_test-indep:
	:

override_dh_auto_install-indep:
	:

# dwz doesn't fully support DWARF-5 yet, see #1016936
override_dh_dwz:
	:

override_dh_gencontrol:
	dh_gencontrol -- -Vrocm:GPU-Architecture="$(shell rocm-target-arch)"

=== debian/tests/control ===
Test-Command: rocm-test-launcher /usr/libexec/rocm/libhipfft0-tests/run-tests
Features: test-name=libhipfft0-tests
Depends: pkg-rocm-tools, libhipfft0-tests
Restrictions: skippable, allow-stderr
Architecture: amd64 arm64 ppc64el

=== debian/watch ===
Version: 5

Source: https://github.com/rocm/hipfft/tags
Matching-Pattern: (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%hipfft-$1.tar.gz%

## hipfft 7.1.0

=== debian/changelog ===
hipfft (7.1.0-0ubuntu3) resolute; urgency=medium

  * No change rebuild due to rocrand upgrade 

 -- Igor Luppi <igor.luppi@canonical.com>  Sat, 14 Feb 2026 15:29:31 -0300

hipfft (7.1.0-0ubuntu2) resolute; urgency=medium

  * d/control: update build-deps w/ llvm-21
  * d/rules: fix hipfft-doc build
  * d/patches: drop doxygen-refs.patch
  * d/patches: add new fix-doxygen-refs.patch
  * d/patches: add new bump-rocm-docs-core-in-docs-sphinx.patch
  * d/patches: add new add-so-version-for-libhipfftw0.patch
  * d/control: new binary package libhipfftw0
  * d/control: add libhipfftw0 as dependency of libhipfft-dev and
    libhipfft0-tests
  * d/rules: use DPKG_GENSYMBOLS_CHECK_LEVEL = 4
  * d/{tests/control,control}: remove ppc64el arch

 -- Bojan Aleksovski <bojan.aleksovski@canonical.com>  Tue, 03 Feb 2026 22:31:06 +0100

hipfft (7.1.0-0ubuntu1) resolute; urgency=medium

  [Talha Can Havadar]
  * d/{rules,control,patches}: make hiprand not optional

  [Alexandre Erwin Ittner]
  * New upstream release.
  * d/patches: remove Switch-find_package-to-module-mode.patch
  * d/control: update Maintainer and Homepage
  * d/libhipfft0.install: include libhipfftw.so*
  * d/libhipfft0.symbols.amd64: include fftw* symbols

 -- Alexandre Erwin Ittner <alexandre.ittner@canonical.com>  Tue, 09 Dec 2025 19:41:45 +0000

hipfft (6.4.3-1~exp1ubuntu1) UNRELEASED; urgency=medium

  * d/control: update maintainer field
  * d/control: update build-depends
  * d/rules: fix FTBFS by adding -Wl,--gc-sections to flags
  * d/rules: use GPU_TARGETS instead of deprecated AMDGPU_TARGETS

 -- Igor Luppi <igor.luppi@canonical.com>  Tue, 28 Oct 2025 09:34:02 -0300

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,29 @@
 Source: hipfft
 Section: devel
-Homepage: https://github.com/ROCm/hipfft
+Homepage: https://github.com/ROCm/rocm-libraries
 Priority: optional
 Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/rocm-team/hipfft.git
 Vcs-Browser: https://salsa.debian.org/rocm-team/hipfft
-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
 Uploaders: Cordell Bloor <cgmb@debian.org>,
+           Maxime Chambonnet <maxzor@maxzor.eu>,
            Christian Kastner <ckk@debian.org>,
            Kari Pahula <kaol@debian.org>,
 Build-Depends: debhelper-compat (= 13),
-               hipcc (>= 5.6.1~),
+               hipcc (>= 7.1.0~),
                cmake,
                rocm-cmake,
-               librocfft-dev (>= 6.4.1~),
+               librocfft-dev (>= 7.1.0~),
                libboost-program-options-dev <!nocheck>,
                libfftw3-dev <!nocheck>,
+               libhiprand-dev (>= 7.1.0~) <!nocheck>,
                libgtest-dev <!nocheck>,
-               pkg-rocm-tools (>= 0.9.0~exp3),
+               pkg-rocm-tools (>= 0.9.4~),
 Build-Depends-Indep: dh-sequence-sphinxdoc <!nodoc>,
                python3-doxysphinx <!nodoc>,
-               python3-rocm-docs (>= 1.20.0-1~) <!nodoc>,
+               python3-rocm-docs (>= 1.31.1-3~) <!nodoc>,
                python3-sphinx-external-toc <!nodoc>,
                libjs-jquery <!nodoc>,
                libjs-mathjax <!nodoc>,
@@ -30,7 +33,7 @@
 
 Package: libhipfft0
 Section: libs
-Architecture: amd64 arm64 ppc64el
+Architecture: amd64 arm64
 XB-X-ROCm-GPU-Architecture: ${rocm:GPU-Architecture}
 Depends: ${misc:Depends}, ${shlibs:Depends},
 Description: portable interface for Fast Fourier Transforms on the GPU - library
@@ -40,11 +43,24 @@
  .
  This package provides the AMD ROCm hipFFT library.
 
+Package: libhipfftw0
+Section: libs
+Architecture: amd64 arm64
+XB-X-ROCm-GPU-Architecture: ${rocm:GPU-Architecture}
+Depends: ${misc:Depends}, ${shlibs:Depends},
+Description: portable interface for Fast Fourier Transforms on the GPU - library
+ hipFFTW is a GPU-aware library for fast Fourier transforms using rocFFT as the
+ backend. It exports an interface borrowing the most commonly-used symbols of
+ FFTW. hipFFTW does not require its computational input and output to be
+ directly accessible by the GPU.
+ .
+ This package provides the AMD ROCm hipFFTW library.
+
 Package: libhipfft-dev
 Section: libdevel
-Architecture: amd64 arm64 ppc64el
-Depends: libhipfft0 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
-         libamdhip64-dev,
+Architecture: amd64 arm64
+Depends: libhipfft0 (= ${binary:Version}),libhipfftw0 (= ${binary:Version}),
+         ${misc:Depends}, ${shlibs:Depends}, libamdhip64-dev,
 Suggests: libhipfft-doc
 Description: portable interface for Fast Fourier Transforms on the GPU - headers
  hipFFT is a wrapper library that provides a common interface to rocFFT and
@@ -55,9 +71,10 @@
 
 Package: libhipfft0-tests
 Section: libdevel
-Architecture: amd64 arm64 ppc64el
+Architecture: amd64 arm64
 Build-Profiles: <!nocheck>
-Depends: libhipfft0 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
+Depends: libhipfft0 (= ${binary:Version}),libhipfftw0 (= ${binary:Version}),
+         ${misc:Depends}, ${shlibs:Depends},
 Description: portable interface for Fast Fourier Transforms on the GPU - tests
  hipFFT is a wrapper library that provides a common interface to rocFFT and
  cuFFT. The hipFFT library is designed to help applications using cuFFT to port

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,14 @@
 export CXX=hipcc
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
 export DEB_CXXFLAGS_MAINT_PREPEND = -gz
+# -Wl,--gc-sections:
+# Fixes linker errors ("relocation refers to a discarded section") when using gtest.
+# The linker's section garbage collection incorrectly discards needed code due to
+# a toolchain mismatch (ROCm's clang vs. the system's GCC). This flag forces the
+# linker to correctly re-evaluate dependencies, keeping the required sections.
+export DEB_LDFLAGS_MAINT_PREPEND = -Wl,--gc-sections
 export VERBOSE=1
+export DPKG_GENSYMBOLS_CHECK_LEVEL = 4
 
 # filter incompatible options from affecting device code
 CXXFLAGS := $(subst -fstack-protector-strong,-Xarch_host -fstack-protector-strong,$(CXXFLAGS))
@@ -17,8 +24,7 @@
 
 # The hipfft test client requires the rocfft sources to build.
 ifeq (,$(filter nocheck,$(DEB_BUILD_PROFILES)))
-CMAKE_FLAGS += -DBUILD_CLIENTS_TESTS=ON \
-	-DUSE_HIPRAND=OFF
+CMAKE_FLAGS += -DBUILD_CLIENTS_TESTS=ON
 endif
 
 %:
@@ -41,13 +47,15 @@
 	:
 
 override_dh_auto_build-indep:
+	:
+
+execute_after_dh_auto_build-indep:
 ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
-	http_proxy='127.0.0.1:9' \
-	https_proxy='127.0.0.1:9' \
-	ROCM_DOCS_REMOTE_DETAILS=http://localhost,local \
-	latest_version= \
-	release_candidate= \
-	sphinx-build -b html docs html
+	export https_proxy=127.0.0.1:9
+	export http_proxy=127.0.0.1:9
+	rocm-docs-build -t html
+	rm -rf html/_static/fonts
+	rm -rf html/_static/vendor
 endif
 
 override_dh_auto_test-indep:
